{-| Module  : FiniteCategories
Description : An example of arrow category.
Copyright   : Guillaume Sabbagh 2021
License     : GPL-3
Maintainer  : guillaumesabbagh@protonmail.com
Stability   : experimental
Portability : portable

An example of arrow category.
-}
module ExampleCommaCategory.ExampleArrowCategory
(
    arrowCategory,
    main
)
where
    import              RandomCompositionGraph.RandomCompositionGraph
    import              System.Random                                   
    import              ExportGraphViz.ExportGraphViz                   (catToPdf,diagToPdf,diagToPdf2)
    import              FiniteCategory.FiniteCategory
    import              CommaCategory.CommaCategory

    (rcg1,newGen) = (mkRandomCompositionGraph 5 10 3 (mkStdGen 8789))
    
    -- | The category of arrows of a random composition graph.
    arrowCategory = mkArrowCategory rcg1

    -- | Export the arrow category as a pdf with GraphViz.
    main = do 
        putStrLn "Start of ExampleArrowCategory"
        catToPdf rcg1 "OutputGraphViz/Examples/CommaCategory/ArrowCategory/rcg"
        catToPdf arrowCategory "OutputGraphViz/Examples/CommaCategory/ArrowCategory/arrow"
        putStrLn "End of ExampleArrowCategory"
        