{-| Module  : FiniteCategories
Description : An example of functor category.
Copyright   : Guillaume Sabbagh 2021
License     : GPL-3
Maintainer  : guillaumesabbagh@protonmail.com
Stability   : experimental
Portability : portable

An example of functor category.
-}
module ExampleFunctorCategory.ExampleFunctorCategory
(
    functorCategory,
    main
)
where
    import              RandomCompositionGraph.RandomCompositionGraph
    import              System.Random                                   
    import              ExportGraphViz.ExportGraphViz
    import              FiniteCategory.FiniteCategory
    import              FunctorCategory.FunctorCategory
    import              Diagram.Diagram
    import              UsualCategories.One
    import              Utils.Sample
    import              Data.Maybe

    (rcg1,newGen) = (mkRandomCompositionGraph 5 10 3 (mkStdGen 87819))
    
    (ob1,newGen1) = (pickOne (ob rcg1) newGen)
    -- diag1 = fromJust (mkSelect1 rcg1 ob1)
    -- diag2 = mkIdentityDiagram rcg1
    -- | The functor category C^1
    functorCategory = FunctorCategory{sourceCat=One, targetCat=rcg1}
    
    recuNatToPdf [] = putStrLn "End of natural transformation export"
    recuNatToPdf (x:xs) = do
                            natToPdf x ("OutputGraphViz/Examples/FunctorCategory/nat"++show (length xs))
                            recuNatToPdf xs

    -- | Export the arrow category as a pdf with GraphViz.
    main = do 
        putStrLn "Start of ExampleFunctorCategory"
        catToPdf rcg1 "OutputGraphViz/Examples/FunctorCategory/rcg"
        catToPdf functorCategory "OutputGraphViz/Examples/FunctorCategory/functorCategory"
        recuNatToPdf (arrows functorCategory)
        putStrLn "End of ExampleFunctorCategory"
        