{-| Module  : FiniteCategories
Description : Run all examples of the project.
Copyright   : Guillaume Sabbagh 2021
License     : GPL-3
Maintainer  : guillaumesabbagh@protonmail.com
Stability   : experimental
Portability : portable

Run all examples of the project. See results in the folder OutputGraphViz.
-}

module Main
(
    main
)
where
    import qualified ExampleCompositionGraph.ExampleCompositionGraph  as ECG
    import qualified ExampleSet.ExampleOrdSet  as OSET
    import qualified ExampleSet.ExamplePowerOrdSet  as POSET
    import qualified ExampleRandomCompositionGraph.ExampleRandomCompositionGraph as RCG
    import qualified ExampleCat.ExampleCat as CAT
    import qualified ExampleCat.ExamplePartialFinCat as PCAT
    import qualified ExampleCat.ExampleFunctor as FUNCT
    import qualified ExampleDiagram.ExampleConstantDiagram as CONSTDIAG
    import qualified ExampleDiagram.ExampleDiscreteDiagram as DISCRETEDIAG
    import qualified ExampleDiagram.ExampleSelectOneDiagram as SELECTONEDIAG
    import qualified ExampleDiagram.ExampleSelectTwoDiagram as SELECTTWODIAG
    import qualified ExampleDiagram.ExampleSelectThreeDiagram as SELECTTHREEDIAG
    import qualified ExampleDiagram.ExampleSelectZeroDiagram as SELECTZERODIAG
    import qualified ExampleDiagram.ExampleParallelDiagram as PARDIAG
    import qualified ExampleDiagram.ExampleDiagram as DIAG
    import qualified ExampleDiagram.ExampleIdentityDiagram as IDDIAG
    import qualified ExampleCommaCategory.ExampleSliceCategory as SLICE
    import qualified ExampleCommaCategory.ExampleCosliceCategory as COSLICE
    import qualified ExampleCommaCategory.ExampleArrowCategory as ARROWCAT
    import qualified ExampleFunctorCategory.ExampleFunctorCategory as FUNCTCAT
    import qualified ExampleDiagonalFunctor.ExampleDiagonalFunctor as DIAGONAL
    import qualified ExampleConeCategory.ExampleConeCategory as CONE
    import qualified ExampleConeCategory.ExampleCoconeCategory as COCONE
    import qualified ExampleConeCategory.ExampleLimit as LIMIT
    import qualified ExampleConeCategory.ExampleColimit as COLIMIT
    import qualified ExampleRandomDiagram.ExampleRandomDiagram as RANDDIAG
    import qualified ExampleRandomDiagram.ExampleRandomTriangle as RANDTRIANGLE
    import qualified ExampleCompositionGraph.ExampleFinSetToCompositionGraph as SETTOCG
    import qualified ExampleCompositionGraph.ExampleCompositionGraphConstruction as CGCONSTRUCT
    import qualified ExampleDiagram.ExampleConversion as CONVERT
    import qualified ExampleCompositionGraph.ExampleSafeCompositionGraph as SCG
    import qualified ExampleSubcategories.ExampleFreeSubcategory as FSC
    import qualified ExampleParsers.ExampleSafeCompositionGraph as PSCG
    import qualified ExampleParsers.ExampleSafeCompositionGraphFunctor as PFSCG
    import qualified ExampleConeCategory.ExampleLeftCone as LCONE
    import qualified ExampleOppositeCategory.ExampleOppositeCategory as OP
    import qualified ExampleSet.ExamplePowerSet as PSET
    import qualified ExampleSet.ExampleSet as SET
    import qualified ExampleYonedaEmbedding.ExampleYonedaEmbedding as YONEDA
    import qualified ExampleSet.ExampleCompletion as COMP
    import qualified ExampleProductCategory.ExampleProductCategory as PROD
    import qualified ExampleCurrying.ExampleCurrying as CURRY
    import qualified ExampleAdjunction.ExampleAdjunction as ADJ

    -- | Run all examples of the project. See results in the folder OutputGraphViz.
    main = do
        ADJ.main
        CURRY.main
        PROD.main
        COMP.main
        YONEDA.main
        SET.main
        PSET.main
        OP.main
        LCONE.main
        PFSCG.main
        PSCG.main
        FSC.main
        SCG.main
        CONVERT.main
        CGCONSTRUCT.main
        SETTOCG.main
        PCAT.main
        RCG.main
        COLIMIT.main
        LIMIT.main
        COCONE.main
        CONE.main
        DIAGONAL.main
        FUNCTCAT.main
        ARROWCAT.main
        COSLICE.main
        SLICE.main
        IDDIAG.main
        DIAG.main
        PARDIAG.main
        SELECTZERODIAG.main
        SELECTTHREEDIAG.main
        SELECTTWODIAG.main
        SELECTONEDIAG.main
        DISCRETEDIAG.main
        CONSTDIAG.main
        FUNCT.main
        CAT.main
        ECG.main
        OSET.main
        POSET.main
        RANDTRIANGLE.main
        RANDDIAG.main
        
        